#include <stdio.h>
#include <stdlib.h>

#ifndef FALSE
#define FALSE 0
#define TRUE (!FALSE)
#endif

#define BOOLEAN int

#define MAXBC 127

int main (int argc, char *argv[])
{
  char buf[MAXBC+1];
  double a, b, c, d, e, val, minv, maxv, totv = 0.0;
  int nf, nval = 0;
  FILE *afh;
  BOOLEAN primo_valore = TRUE;

  if (argc != 3)
  {
    fprintf (stderr, "errore: fornire nome del file e indice della filiale\n");
    exit (1);
  }

  afh = fopen (argv[1], "r");
  if (afh == NULL)
  {
    fprintf (stderr, "errore: impossibile aprire il file '%s' in lettura\n", argv[1]);
    exit (2);
  }

  if (sscanf(argv[2],"%d",&nf) != 1)
  {
    fprintf (stderr, "errore: l'indice della filiale non e' un numero intero\n");
    exit (3);
  }
  if (nf<1 || nf>5)
  {
    fprintf (stderr, "errore: l'indice della filiale (%s) non e' valido\n", argv[2]);
    exit (4);
  }

  while (fgets(buf,MAXBC+1,afh) != NULL)
  {
    /* leggo i dati delle filiali */
	
    if (sscanf (buf, "%lf %lf %lf %lf %lf", &a, &b, &c, &d, &e) != 5)
    {
      fprintf (stderr,
       "avviso - questa riga non contiene cinque dati e viene scartata:\n%s\n", buf);
      continue;
    }
	
	/* seleziono il valore da considerare per i calcoli */

    switch (nf)
    {
    case 1: val = a; break;
    case 2: val = b; break;
    case 3: val = c; break;
    case 4: val = d; break;
    case 5: val = e; break;
    default:
      fprintf (stderr, "bug: valore impossibile (nf=%d)\n", nf);
      exit (5);
    }
	
	/* aggiorno min, max, e totale */
	
    if (primo_valore)
    {
      minv = val;
      maxv = val;
      primo_valore = FALSE;
    }
    else /* non e' il primo_valore */
    {
      if (val < minv)
        minv = val;
      if (val > maxv)
        maxv = val;
    }
    nval++;
    totv += val;
  }

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso: non sono riuscito a chiudere il file '%s'\n", argv[1]);

  if (nval > 0)
    printf ("Filiale n.%d: min=%.2lf max=%.2lf med=%.2lf\n", nf, minv, maxv, totv/nval);
  else
    printf ("Non sono stati forniti dati: impossibile eseguire le statistiche\n");

  return 0;
}

