/**************************************

MODULO: interv.c

SCOPO: genera tutti i valori interi di
un intervallo i cui limiti sono forniti
sulla linea di comando

**************************************/

#include <stdio.h>
#include <stdlib.h>


int main (int argc, char *argv[])
{
  long i;
  long imin, imax;

  /* controllo che i limiti siano stati inseriti */

  if (argc != 3)
  {
    fprintf (stderr, "errore - inserire i limiti dell'intervallo\n");
    exit (1);
  }

  /* leggo i limiti e controllo che siano numeri interi */

  if (sscanf(argv[1],"%ld",&imin) != 1)
  {
    fprintf (stderr, "errore - il limite inserito (%s) non e' un intero\n", argv[1]);
    exit (2);
  }

  if (sscanf(argv[2],"%ld",&imax) != 1)
  {
    fprintf (stderr, "errore - il limite inserito (%s) non e' un intero\n", argv[2]);
    exit (3);
  }

  /* stampo l'intervallo */

  for (i=imin; i<=imax; i++)
    printf ("%ld\n", i);

  return 0;
}
