#include <stdio.h>
#include <ctype.h>

int main (int argc, char *argv[])
{
  FILE *afh;
  FILE *bfh;
  int xc;

  if (argc != 3)
  {
    fprintf (stderr, "errore: occorrono i nomi di due file\n");
    return 1;
  }

  afh = fopen (argv[1], "r");
  if (afh == NULL)
  {
    fprintf (stderr, "errore: impossibile aprire in lettura il file '%s'\n", argv[1]);
    return 2;
  }

  bfh = fopen (argv[2], "w");
  if (bfh == NULL)
  {
    fprintf (stderr, "errore: impossibile aprire in scrittura il file '%s'\n", argv[2]);
    return 3;
  }

  while ((xc=fgetc(afh)) != EOF)
  {
    if (fputc (toupper(xc), bfh) == EOF)
    {
      fprintf (stderr, "errore - scrittura dati sul file '%s' fallita\n", argv[2]);
      return 4;
    }
  }

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso: non sono riuscito a chiudere il file '%s'\n", argv[1]);
  if (fclose(bfh) != 0) {
    fprintf (stderr, "avviso: non sono riuscito a chiudere il file '%s';", argv[2]);
    fprintf (stderr, " la copia potrebbe non essere riuscita\n");
  }

  return 0;
}
