#include <stdio.h>
#include <string.h>

/* lunghezza minima e massima del cateto */
#define LC_MIN 1
#define LC_MAX 23

int main (int argc, char *argv[])
{
  char cs; /* Carattere da usare per la Stampa */
  int lcateto; /* lunghezza del cateto */
  int riga;

  if (argc != 3)
  {
    fprintf (stderr, "errore - numero di parametri errato\n");
    return 1;
  }

  if (strlen(argv[1]) != 1)
  {
    fprintf (stderr, "errore - fornire uno ed uno solo carattere per la stampa\n");
    return 2;
  }
  cs = argv[1][0];

  if (sscanf(argv[2],"%d",&lcateto) != 1)
  {
    fprintf (stderr, "errore - parametro '%s' non valido come lunghezza\n", argv[2]);
    return 3;
  }
  if ((lcateto > LC_MAX) || (lcateto < LC_MIN))
  {
    fprintf (stderr, "lunghezza del cateto non valida (%d-%d)\n", LC_MIN, LC_MAX);
    return 4;
  }

  for (riga=1; riga<=lcateto; riga++)
  {
    int colonna;
    for (colonna=1; colonna<=riga; colonna++)
      putchar (cs);
    putchar ('\n');
  }

  return 0;
}
