#include <stdio.h>
#include <stdlib.h>

#define MAXBC 127
#define N_STUDENTI 100
#define N_ESAMI 30

int main (int argc, char *argv[])
{
  struct {
    unsigned int n_studenti;
    unsigned long totale_voti;
  }
  esame[N_ESAMI];

  char buf[MAXBC+1];
  int i;
  FILE *afh;

  /* controllo dei parametri */

  if (argc != 2) {
    fprintf (stderr, "errore - inserire il nome del file di input\n");
    exit (1);
  }

  /* apertura del file di input */

  if ((afh = fopen (argv[1], "r")) == NULL) {
    fprintf (stderr, "errore - impossibile aprire il file '%s' in lettura\n", argv[1]);
    exit (2);
  }

  /* azzeramento dei dati degli esami */

  for (i=0; i<N_ESAMI; i++) {
    esame[i].n_studenti = 0;
    esame[i].totale_voti = 0;
  }

  /* lettura dei dati */

  while (fgets(buf,MAXBC,afh) != NULL)
  {
    int istud, iexam, voto;
    if (sscanf(buf,"%d %d %d",&istud,&iexam,&voto) != 3) {
      fprintf (stderr, "errore - formato di input errato (%s)\n", buf);
      exit (3);
    }
    if (istud<0 || istud>=N_STUDENTI) {
      fprintf (stderr, "errore - studente sconosciuto nella riga '%s'\n", buf);
      exit (4);
    }
    if (iexam<0 || iexam>=N_ESAMI) {
      fprintf (stderr, "errore - esame sconosciuto nella riga '%s'\n", buf);
      exit (5);
    }
    if (voto <= 0) {
      fprintf (stderr, "errore - voto impossibile nella riga '%s'\n", buf);
      exit (6);
    }
    esame[iexam].n_studenti++;
    esame[iexam].totale_voti += voto;
  }

  /* calcolo delle medie */

  for (i=0; i<N_ESAMI; i++)
  {
    printf ("- esame n.%d : ", i);
    if (esame[i].n_studenti == 0)
      printf ("non sostenuto da alcun studente\n");
    else
      printf ("voto medio %5.2lf\n", (double)esame[i].totale_voti / esame[i].n_studenti);
  }

  /* chiusura del file */

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso - la chiusura del file '%s' e' fallita\n", argv[1]);

  /* termine del programma */

  return 0;
}
